# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.object import Object


class OpenGLUniforms(Object):
    """
    OpenGLUniforms - no description provided.
    
    Superclass: Object
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkOpenGLUniforms, obj, update, **traits)
    
    def _get_declarations(self):
        return self._vtk_obj.GetDeclarations()
    declarations = traits.Property(_get_declarations, desc=\
        """
        
        """
    )

    def _get_uniform_list_m_time(self):
        return self._vtk_obj.GetUniformListMTime()
    uniform_list_m_time = traits.Property(_get_uniform_list_m_time, desc=\
        """
        
        """
    )

    def add_uniform1fv(self, *args):
        """
        V.add_uniform1fv(string, int, (float, ...))
        C++: void AddUniform1fv(const char *name, const int count,
            const float *f)"""
        ret = self._wrap_call(self._vtk_obj.AddUniform1fv, *args)
        return ret

    def add_uniform1iv(self, *args):
        """
        V.add_uniform1iv(string, int, (int, ...))
        C++: void AddUniform1iv(const char *name, const int count,
            const int *f)
        Add the name uniform array to f with count elements
        """
        ret = self._wrap_call(self._vtk_obj.AddUniform1iv, *args)
        return ret

    def add_uniform2f(self, *args):
        """
        V.add_uniform2f(string, (float, float))
        C++: void AddUniform2f(const char *name,
            const float defaultValue[2])"""
        ret = self._wrap_call(self._vtk_obj.AddUniform2f, *args)
        return ret

    def add_uniform2i(self, *args):
        """
        V.add_uniform2i(string, (int, int))
        C++: void AddUniform2i(const char *name,
            const int defaultValue[2])"""
        ret = self._wrap_call(self._vtk_obj.AddUniform2i, *args)
        return ret

    def add_uniform3f(self, *args):
        """
        V.add_uniform3f(string, (float, float, float))
        C++: void AddUniform3f(const char *name,
            const double defaultValue[3])"""
        ret = self._wrap_call(self._vtk_obj.AddUniform3f, *args)
        return ret

    def add_uniform3uc(self, *args):
        """
        V.add_uniform3uc(string, (int, int, int))
        C++: void AddUniform3uc(const char *name,
            const unsigned char defaultValue[3])"""
        ret = self._wrap_call(self._vtk_obj.AddUniform3uc, *args)
        return ret

    def add_uniform4f(self, *args):
        """
        V.add_uniform4f(string, (float, float, float, float))
        C++: void AddUniform4f(const char *name,
            const float defaultValue[4])"""
        ret = self._wrap_call(self._vtk_obj.AddUniform4f, *args)
        return ret

    def add_uniform4uc(self, *args):
        """
        V.add_uniform4uc(string, (int, int, int, int))
        C++: void AddUniform4uc(const char *name,
            const unsigned char defaultValue[4])"""
        ret = self._wrap_call(self._vtk_obj.AddUniform4uc, *args)
        return ret

    def add_uniform_matrix(self, *args):
        """
        V.add_uniform_matrix(string, Matrix3x3)
        C++: void AddUniformMatrix(const char *name,
            Matrix3x3 *defaultValue)
        V.add_uniform_matrix(string, Matrix4x4)
        C++: void AddUniformMatrix(const char *name,
            Matrix4x4 *defaultValue)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.AddUniformMatrix, *my_args)
        return ret

    def add_uniform_matrix3x3(self, *args):
        """
        V.add_uniform_matrix3x3(string, [float, ...])
        C++: void AddUniformMatrix3x3(const char *name,
            float *defaultValue)"""
        ret = self._wrap_call(self._vtk_obj.AddUniformMatrix3x3, *args)
        return ret

    def add_uniform_matrix4x4(self, *args):
        """
        V.add_uniform_matrix4x4(string, [float, ...])
        C++: void AddUniformMatrix4x4(const char *name,
            float *defaultValue)"""
        ret = self._wrap_call(self._vtk_obj.AddUniformMatrix4x4, *args)
        return ret

    def add_uniform_matrix4x4v(self, *args):
        """
        V.add_uniform_matrix4x4v(string, int, [float, ...])
        C++: void AddUniformMatrix4x4v(const char *name, const int count,
            float *v)"""
        ret = self._wrap_call(self._vtk_obj.AddUniformMatrix4x4v, *args)
        return ret

    def add_uniformf(self, *args):
        """
        V.add_uniformf(string, float)
        C++: void AddUniformf(const char *name, float defaultValue)"""
        ret = self._wrap_call(self._vtk_obj.AddUniformf, *args)
        return ret

    def add_uniformi(self, *args):
        """
        V.add_uniformi(string, int)
        C++: void AddUniformi(const char *name, int defaultValue)
        Add the name uniform variable with value default_value.
        """
        ret = self._wrap_call(self._vtk_obj.AddUniformi, *args)
        return ret

    def remove_all_uniforms(self):
        """
        V.remove_all_uniforms()
        C++: void RemoveAllUniforms()
        Remove all uniform variables
        """
        ret = self._vtk_obj.RemoveAllUniforms()
        return ret
        

    def remove_uniform(self, *args):
        """
        V.remove_uniform(string)
        C++: void RemoveUniform(const char *name)
        Remove uniform variable named name
        """
        ret = self._wrap_call(self._vtk_obj.RemoveUniform, *args)
        return ret

    def set_uniform1fv(self, *args):
        """
        V.set_uniform1fv(string, int, (float, ...))
        C++: void SetUniform1fv(const char *name, const int count,
            const float *f)"""
        ret = self._wrap_call(self._vtk_obj.SetUniform1fv, *args)
        return ret

    def set_uniform1iv(self, *args):
        """
        V.set_uniform1iv(string, int, (int, ...))
        C++: void SetUniform1iv(const char *name, const int count,
            const int *f)
        Set the name uniform array to f with count elements
        """
        ret = self._wrap_call(self._vtk_obj.SetUniform1iv, *args)
        return ret

    def set_uniform2f(self, *args):
        """
        V.set_uniform2f(string, (float, float))
        C++: void SetUniform2f(const char *name, const float v[2])"""
        ret = self._wrap_call(self._vtk_obj.SetUniform2f, *args)
        return ret

    def set_uniform2i(self, *args):
        """
        V.set_uniform2i(string, (int, int))
        C++: void SetUniform2i(const char *name, const int v[2])"""
        ret = self._wrap_call(self._vtk_obj.SetUniform2i, *args)
        return ret

    def set_uniform3f(self, *args):
        """
        V.set_uniform3f(string, (float, float, float))
        C++: void SetUniform3f(const char *name, const double v[3])"""
        ret = self._wrap_call(self._vtk_obj.SetUniform3f, *args)
        return ret

    def set_uniform3uc(self, *args):
        """
        V.set_uniform3uc(string, (int, int, int))
        C++: void SetUniform3uc(const char *name,
            const unsigned char v[3])"""
        ret = self._wrap_call(self._vtk_obj.SetUniform3uc, *args)
        return ret

    def set_uniform4f(self, *args):
        """
        V.set_uniform4f(string, (float, float, float, float))
        C++: void SetUniform4f(const char *name, const float v[4])"""
        ret = self._wrap_call(self._vtk_obj.SetUniform4f, *args)
        return ret

    def set_uniform4uc(self, *args):
        """
        V.set_uniform4uc(string, (int, int, int, int))
        C++: void SetUniform4uc(const char *name,
            const unsigned char v[4])"""
        ret = self._wrap_call(self._vtk_obj.SetUniform4uc, *args)
        return ret

    def set_uniform_matrix(self, *args):
        """
        V.set_uniform_matrix(string, Matrix3x3)
        C++: void SetUniformMatrix(const char *name, Matrix3x3 *v)
        V.set_uniform_matrix(string, Matrix4x4)
        C++: void SetUniformMatrix(const char *name, Matrix4x4 *v)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SetUniformMatrix, *my_args)
        return ret

    def set_uniform_matrix3x3(self, *args):
        """
        V.set_uniform_matrix3x3(string, [float, ...])
        C++: void SetUniformMatrix3x3(const char *name, float *v)"""
        ret = self._wrap_call(self._vtk_obj.SetUniformMatrix3x3, *args)
        return ret

    def set_uniform_matrix4x4(self, *args):
        """
        V.set_uniform_matrix4x4(string, [float, ...])
        C++: void SetUniformMatrix4x4(const char *name, float *v)"""
        ret = self._wrap_call(self._vtk_obj.SetUniformMatrix4x4, *args)
        return ret

    def set_uniform_matrix4x4v(self, *args):
        """
        V.set_uniform_matrix4x4v(string, int, [float, ...])
        C++: void SetUniformMatrix4x4v(const char *name, const int count,
            float *v)"""
        ret = self._wrap_call(self._vtk_obj.SetUniformMatrix4x4v, *args)
        return ret

    def set_uniformf(self, *args):
        """
        V.set_uniformf(string, float)
        C++: void SetUniformf(const char *name, float v)"""
        ret = self._wrap_call(self._vtk_obj.SetUniformf, *args)
        return ret

    def set_uniformi(self, *args):
        """
        V.set_uniformi(string, int)
        C++: void SetUniformi(const char *name, int v)
        Set the name uniform value to v.
        """
        ret = self._wrap_call(self._vtk_obj.SetUniformi, *args)
        return ret

    def set_uniforms(self, *args):
        """
        V.set_uniforms(ShaderProgram) -> bool
        C++: bool SetUniforms(ShaderProgram *p)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SetUniforms, *my_args)
        return ret

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(OpenGLUniforms, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit OpenGLUniforms properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], []),
            title='Edit OpenGLUniforms properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit OpenGLUniforms properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

